<template>
  <div>
    <item
      v-for="item in leafs[null]"
      :key="item.id"
      :leafs="leafs"
      :item="item"
    />
  </div>
</template>

<script>
  import endpointsMixin from '../../../../mixins/endpointsMixin';
  import Item from './item';

  export default {
    name: 'sidebar',
    components: { Item },
    mixins: [endpointsMixin],
    computed: {
      leafs() {
        const leafs = {};

        this.items.forEach(({ parent_id: parent, ...item }) => {
          if (!((parent || null) in leafs)) {
            leafs[parent || null] = [];
          }
          leafs[parent || null].push(item);
        });

        Object.keys(leafs).forEach((key) => {
          leafs[key].sort((a, b) => a.order_position - b.order_position);
        });

        return leafs;
      },
    },
    data() {
      return {
        items: [],
      };
    },
    created() {
      this.loadMenu();

      this.$eventHub.$on('menuReordered', this.loadMenu);
    },
    methods: {
      loadMenu() {
        this.fetchMenuItems()
          .then((menu) => {
            this.items = menu;
          });
      },
    },
  };
</script>
